"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MlkitBarcodeView = exports.BARCODE = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _MlkitBarcodeViewManager = require("./MlkitBarcodeViewManager");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const BARCODE = {
  FORMAT_UNKNOWN: -1,
  FORMAT_ALL_FORMATS: 0,
  FORMAT_CODE_128: 1,
  FORMAT_CODE_39: 2,
  FORMAT_CODE_93: 4,
  FORMAT_CODABAR: 8,
  FORMAT_DATA_MATRIX: 16,
  FORMAT_EAN_13: 32,
  FORMAT_EAN_8: 64,
  FORMAT_ITF: 128,
  FORMAT_QR_CODE: 256,
  FORMAT_UPC_A: 512,
  FORMAT_UPC_E: 1024,
  FORMAT_PDF417: 2048,
  FORMAT_AZTEC: 4096
  //  TYPE_UNKNOWN : 0,
  //  TYPE_CONTACT_INFO : 1,
  //  TYPE_EMAIL : 2,
  //  TYPE_ISBN : 3,
  //  TYPE_PHONE : 4,
  //  TYPE_PRODUCT : 5,
  //  TYPE_SMS : 6,
  //  TYPE_TEXT : 7,
  //  TYPE_URL : 8,
  //  TYPE_WIFI : 9,
  //  TYPE_GEO : 10,
  //  TYPE_CALENDAR_EVENT : 11,
  //  TYPE_DRIVER_LICENSE : 12,
};
exports.BARCODE = BARCODE;
const createFragment = viewId => {
  console.log(TAG, "Create Frag ViewId :", viewId);
  _reactNative.UIManager.dispatchViewManagerCommand(viewId,
  // we are calling the 'create' command
  "create", [viewId]);
};
const destroyFragment = viewId => {
  console.log(TAG, "Destroy Frag ViewId :", viewId);
  _reactNative.UIManager.dispatchViewManagerCommand(viewId,
  // we are calling the 'create' command
  "destroy", [viewId]);
};
const eventEmitter = new _reactNative.NativeEventEmitter();
const TAG = "MlkitBarcodeView: ";
class MlkitBarcodeView extends _react.PureComponent {
  constructor(props) {
    super(props);
    _defineProperty(this, "startScanner", () => {
      // console.log(TAG, "startScanner.... enableScan :"+this.state.enableScan);
      this.eventListener = eventEmitter.addListener('BARCODE_SCANNED', event => {
        console.log(event); // "someValue"
        if (this.props.onSuccess) this.props.onSuccess(event);
      });
      const viewId = (0, _reactNative.findNodeHandle)(this.ref.current);
      createFragment(viewId);
    });
    this.state = {
      enableScan: this.props.enableScanner
    };
    this.ref = /*#__PURE__*/(0, _react.createRef)();
  }
  componentDidMount() {
    console.log(TAG, "componentDidMount.");
    if (this.props.enableScanner) setTimeout(this.startScanner, 200);
    // this.startScanner();
  }

  componentWillUnmount() {
    // Here goes the code you wish to run on unmount
    console.log(TAG, "WillUnmount.");
    // const viewId = findNodeHandle(this.ref.current);
    // destroyFragment(viewId);
    // this.setState({enableScan:false});
    this.eventListener && this.eventListener.remove();
  }
  UNSAFE_componentWillReceiveProps(newProps) {
    if (newProps.enableScanner && !this.state.enableScan) {
      this.setState({
        enableScan: true
      }, () => {
        // console.log(TAG,"Starting Scanner enableScan");
        setTimeout(this.startScanner, 400);
      });
    } else if (!newProps.enableScanner && this.state.enableScan) {
      this.setState({
        enableScan: newProps.enableScanner
      });
    }

    //BarCode updated restart scanner.
    if (this.props.enableScanner && newProps.barcodeFormat != this.props.barcodeFormat) {
      this.setState({
        enableScanner: false
      }, () => {
        setTimeout(() => {
          this.setState({
            enableScan: true
          }, () => {
            // console.log(TAG,"Starting Scanner BarcodeFormate Changed");
            setTimeout(this.startScanner, 400);
          });
        }, 700);
      });
    }
    this.props = newProps;
  }
  render() {
    if (this.state.enableScan) {
      return /*#__PURE__*/_react.default.createElement(_MlkitBarcodeViewManager.MlkitBarcodeViewManager, _extends({}, this.props, {
        ref: this.ref
      }));
    } else return null;
  }
}
exports.MlkitBarcodeView = MlkitBarcodeView;
;
//# sourceMappingURL=index.js.map