function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { createRef, PureComponent, useEffect, useRef, useState } from 'react';
import { UIManager, findNodeHandle, NativeEventEmitter, View } from 'react-native';
import { MlkitBarcodeViewManager } from './MlkitBarcodeViewManager';
export const BARCODE = {
  FORMAT_UNKNOWN: -1,
  FORMAT_ALL_FORMATS: 0,
  FORMAT_CODE_128: 1,
  FORMAT_CODE_39: 2,
  FORMAT_CODE_93: 4,
  FORMAT_CODABAR: 8,
  FORMAT_DATA_MATRIX: 16,
  FORMAT_EAN_13: 32,
  FORMAT_EAN_8: 64,
  FORMAT_ITF: 128,
  FORMAT_QR_CODE: 256,
  FORMAT_UPC_A: 512,
  FORMAT_UPC_E: 1024,
  FORMAT_PDF417: 2048,
  FORMAT_AZTEC: 4096
  //  TYPE_UNKNOWN : 0,
  //  TYPE_CONTACT_INFO : 1,
  //  TYPE_EMAIL : 2,
  //  TYPE_ISBN : 3,
  //  TYPE_PHONE : 4,
  //  TYPE_PRODUCT : 5,
  //  TYPE_SMS : 6,
  //  TYPE_TEXT : 7,
  //  TYPE_URL : 8,
  //  TYPE_WIFI : 9,
  //  TYPE_GEO : 10,
  //  TYPE_CALENDAR_EVENT : 11,
  //  TYPE_DRIVER_LICENSE : 12,
};

const createFragment = viewId => {
  console.log(TAG, "Create Frag ViewId :", viewId);
  UIManager.dispatchViewManagerCommand(viewId,
  // we are calling the 'create' command
  "create", [viewId]);
};
const destroyFragment = viewId => {
  console.log(TAG, "Destroy Frag ViewId :", viewId);
  UIManager.dispatchViewManagerCommand(viewId,
  // we are calling the 'create' command
  "destroy", [viewId]);
};
const eventEmitter = new NativeEventEmitter();
const TAG = "MlkitBarcodeView: ";
export class MlkitBarcodeView extends PureComponent {
  constructor(props) {
    super(props);
    _defineProperty(this, "startScanner", () => {
      // console.log(TAG, "startScanner.... enableScan :"+this.state.enableScan);
      this.eventListener = eventEmitter.addListener('BARCODE_SCANNED', event => {
        console.log(event); // "someValue"
        if (this.props.onSuccess) this.props.onSuccess(event);
      });
      const viewId = findNodeHandle(this.ref.current);
      createFragment(viewId);
    });
    this.state = {
      enableScan: this.props.enableScanner
    };
    this.ref = /*#__PURE__*/createRef();
  }
  componentDidMount() {
    console.log(TAG, "componentDidMount.");
    if (this.props.enableScanner) setTimeout(this.startScanner, 200);
    // this.startScanner();
  }

  componentWillUnmount() {
    // Here goes the code you wish to run on unmount
    console.log(TAG, "WillUnmount.");
    // const viewId = findNodeHandle(this.ref.current);
    // destroyFragment(viewId);
    // this.setState({enableScan:false});
    this.eventListener && this.eventListener.remove();
  }
  UNSAFE_componentWillReceiveProps(newProps) {
    if (newProps.enableScanner && !this.state.enableScan) {
      this.setState({
        enableScan: true
      }, () => {
        // console.log(TAG,"Starting Scanner enableScan");
        setTimeout(this.startScanner, 400);
      });
    } else if (!newProps.enableScanner && this.state.enableScan) {
      this.setState({
        enableScan: newProps.enableScanner
      });
    }

    //BarCode updated restart scanner.
    if (this.props.enableScanner && newProps.barcodeFormat != this.props.barcodeFormat) {
      this.setState({
        enableScanner: false
      }, () => {
        setTimeout(() => {
          this.setState({
            enableScan: true
          }, () => {
            // console.log(TAG,"Starting Scanner BarcodeFormate Changed");
            setTimeout(this.startScanner, 400);
          });
        }, 700);
      });
    }
    this.props = newProps;
  }
  render() {
    if (this.state.enableScan) {
      return /*#__PURE__*/React.createElement(MlkitBarcodeViewManager, _extends({}, this.props, {
        ref: this.ref
      }));
    } else return null;
  }
}
;
//# sourceMappingURL=index.js.map